Index: /palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4842)
@@ -24,4 +24,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Enable 3D data output also with 64-bit precision
 !
@@ -664,54 +668,60 @@
 !> Parin for &bulk_cloud_parameters for the bulk cloud module
 !--------------------------------------------------------------------------------------------------!
-    SUBROUTINE bcm_parin
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=80)  ::  line  !< dummy string that contains the current line of the parameter
-                                     !< file
-
-       NAMELIST /bulk_cloud_parameters/                                                            &
-          aerosol_bulk,                                                                            &
-          bulk_cloud_model,                                                                        &
-          c_sedimentation,                                                                         &
-          call_microphysics_at_all_substeps,                                                       &
-          cloud_scheme,                                                                            &
-          cloud_water_sedimentation,                                                               &
-          collision_turbulence,                                                                    &
-          curvature_solution_effects_bulk,                                                         &
-          dry_aerosol_radius,                                                                      &
-          graupel,                                                                                 &
-          ice_crystal_sedimentation,                                                               &
-          in_init,                                                                                 &
-          limiter_sedimentation,                                                                   &
-          microphysics_ice_phase,                                                                  &
-          na_init,                                                                                 &
-          nc_const,                                                                                &
-          sigma_bulk,                                                                              &
-          snow,                                                                                    &
-          start_ice_microphysics,                                                                  &
-          ventilation_effect
-
-       line = ' '
-!
-!--    Try to find bulk cloud module namelist
-       REWIND ( 11 )
-       line = ' '
-       DO   WHILE ( INDEX( line, '&bulk_cloud_parameters' ) == 0 )
-          READ ( 11, '(A)', END=10 )  line
-       ENDDO
-       BACKSPACE ( 11 )
-!
-!--    Read user-defined namelist
-       READ ( 11, bulk_cloud_parameters )
-!
-!--    Set flag that indicates that the bulk cloud module is switched on
-       !bulk_cloud_model = .TRUE.
-
-10     CONTINUE
-
-
-    END SUBROUTINE bcm_parin
+ SUBROUTINE bcm_parin
+
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=100)  ::  line  !< Dummy string that contains the current line of the parameter
+                                  !< file
+
+    INTEGER(iwp)  ::  io_status   !< Status after reading the namelist file
+
+
+    NAMELIST /bulk_cloud_parameters/                                                               &
+       aerosol_bulk,                                                                               &
+       bulk_cloud_model,                                                                           &
+       c_sedimentation,                                                                            &
+       call_microphysics_at_all_substeps,                                                          &
+       cloud_scheme,                                                                               &
+       cloud_water_sedimentation,                                                                  &
+       collision_turbulence,                                                                       &
+       curvature_solution_effects_bulk,                                                            &
+       dry_aerosol_radius,                                                                         &
+       graupel,                                                                                    &
+       ice_crystal_sedimentation,                                                                  &
+       in_init,                                                                                    &
+       limiter_sedimentation,                                                                      &
+       microphysics_ice_phase,                                                                     &
+       na_init,                                                                                    &
+       nc_const,                                                                                   &
+       sigma_bulk,                                                                                 &
+       snow,                                                                                       &
+       start_ice_microphysics,                                                                     &
+       ventilation_effect
+
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, bulk_cloud_parameters, IOSTAT=io_status )
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    bulk_cloud_parameters namelist was found and read correctly. Set flag that
+!--    bulk_cloud_model_mod is switched on.
+       bulk_cloud_model = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    bulk_cloud_parameters namelist was found, but contained errors. Print an error message
+!--    containing the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'bulk_cloud_parameters', line )
+
+    ENDIF
+
+ END SUBROUTINE bcm_parin
 
 
Index: /palm/trunk/SOURCE/dynamics_mod.f90
===================================================================
--- /palm/trunk/SOURCE/dynamics_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/dynamics_mod.f90	(revision 4842)
@@ -24,4 +24,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Enable 3D data output also with 64-bit precision
 !
@@ -336,33 +340,30 @@
 
 
-    CHARACTER (LEN=80)  ::  line  !< dummy string that contains the current line of the parameter file
-
-    NAMELIST /dynamics_parameters/                                                                 &
-       dynamics_module_enabled
-
-
-    line = ' '
-!
-!-- Try to find module-specific namelist
-    REWIND ( 11 )
-    line = ' '
-    DO   WHILE ( INDEX( line, '&dynamics_parameters' ) == 0 )
-       READ ( 11, '(A)', END=12 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!-- Set default module switch to true
+    CHARACTER(LEN=100)  ::  line  !< dummy string that contains the current line of the parameter
+                                  !< file
+    INTEGER(iwp)  ::  io_status   !< status after reading the namelist file
+
+    
+    NAMELIST /dynamics_parameters/  dynamics_module_enabled
+
+!
+!-- Set default module switch to true.
     dynamics_module_enabled = .TRUE.
 
-!-- Read user-defined namelist
-    READ ( 11, dynamics_parameters, ERR = 10 )
-
-    GOTO 12
-
-10  BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'dynamics_parameters', line )
-
-12  CONTINUE
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, dynamics_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status > 0 )  THEN
+!
+!--    dynamics_parameters namelist was found, but contained errors. Print an error message
+!--    including the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'dynamics_parameters', line )
+
+    ENDIF
 
  END SUBROUTINE dynamics_parin
Index: /palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- /palm/trunk/SOURCE/gust_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/gust_mod.f90	(revision 4842)
@@ -24,4 +24,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Enable 3D data output also with 64-bit precision
 !
@@ -213,34 +217,40 @@
 !> Parin for &gust_parameters for gust module
 !--------------------------------------------------------------------------------------------------!
-    SUBROUTINE gust_parin
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=80)  ::  line  !< dummy string that contains the current line of the parameter file
-
-       NAMELIST /gust_parameters/                                                                  &
-          gust_module_enabled
-
-       line = ' '
-!
-!--    Try to find gust module package
-       REWIND ( 11 )
-       line = ' '
-       DO   WHILE ( INDEX( line, '&gust_parameters' ) == 0 )
-          READ ( 11, '(A)', END=10 )  line
-       ENDDO
-       BACKSPACE ( 11 )
-!
-!--    Read user-defined namelist
-       READ ( 11, gust_parameters )
-!
-!--    Set flag that indicates that the gust module is switched on
+ SUBROUTINE gust_parin
+
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=100)  ::  line  !< dummy string that contains the current line of the parameter
+                                  !< file
+    INTEGER(iwp)  ::  io_status   !< status after reading the namelist file
+
+
+    NAMELIST /gust_parameters/  gust_module_enabled
+
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, gust_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    gust_parameters namelist was found and read correctly. Set flag that indicates that the gust
+!--    module is switched on.
        gust_module_enabled = .TRUE.
 
-10     CONTINUE
-
-
-    END SUBROUTINE gust_parin
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    gust_parameters namelist was found, but contained errors. Print an error message including
+!--    the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'gust_parameters', line )
+
+    ENDIF
+
+ END SUBROUTINE gust_parin
 
 
Index: /palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4842)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Change parameters for summer_pars and winter_pars (responsible: S. Rissmann)
 !
@@ -1903,5 +1907,5 @@
         CASE ( 'im_t_indoor_wall_win' )
            unit = 'K'
-           
+
         CASE ( 'im_t_indoor_wall' )
            unit = 'K'
@@ -2123,25 +2127,34 @@
 
 
-    CHARACTER (LEN=80) ::  line  !< string containing current line of file PARIN
+    CHARACTER(LEN=100) ::  line  !< string containing current line of file PARIN
+
+    INTEGER(iwp)  ::  io_status  !< status after reading the namelist file
+
 
     NAMELIST /indoor_parameters/  indoor_during_spinup,                                            &
                                   initial_indoor_temperature
 
-
-!
-!-- Try to find indoor model package
-    REWIND ( 11 )
-    line = ' '
-    DO  WHILE ( INDEX( line, '&indoor_parameters' ) == 0 )
-       READ ( 11, '(A)', END=10 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read user-defined namelist
-    READ ( 11, indoor_parameters )
-!
-!-- Set flag that indicates that the indoor model is switched on
-    indoor_model = .TRUE.
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, indoor_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    indoor_parameters namelist was found and read correctly. Set flag that indicates that the
+!--    indoor model is switched on.
+       indoor_model = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    indoor_parameters namelist was found, but contained errors. Print an error message including
+!--    the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)' ) line
+       CALL parin_fail_message( 'indoor_parameters', line )
+
+    ENDIF
 
 !
@@ -2156,6 +2169,4 @@
 !        ENDIF
 
- 10 CONTINUE
-
  END SUBROUTINE im_parin
 
Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4842)
@@ -24,4 +24,9 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more,
+! deprecated namelist removed
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! output of particle time series added
 !
@@ -569,65 +574,7 @@
  SUBROUTINE lpm_parin
 
-    CHARACTER (LEN=80) ::  line  !<
-
-    NAMELIST /particles_par/                                                                       &
-       aero_species,                                                                               &
-       aero_type,                                                                                  &
-       aero_weight,                                                                                &
-       alloc_factor,                                                                               &
-       bc_par_b,                                                                                   &
-       bc_par_lr,                                                                                  &
-       bc_par_ns,                                                                                  &
-       bc_par_t,                                                                                   &
-       collision_kernel,                                                                           &
-       curvature_solution_effects,                                                                 &
-       deallocate_memory,                                                                          &
-       density_ratio,                                                                              &
-       dissipation_classes,                                                                        &
-       dt_dopts,                                                                                   &
-       dt_min_part,                                                                                &
-       dt_prel,                                                                                    &
-       dt_write_particle_data,                                                                     &
-       end_time_prel,                                                                              &
-       initial_weighting_factor,                                                                   &
-       log_sigma,                                                                                  &
-       max_number_particles_per_gridbox,                                                           &
-       merging,                                                                                    &
-       na,                                                                                         &
-       number_concentration,                                                                       &
-       number_of_particle_groups,                                                                  &
-       number_particles_per_gridbox,                                                               &
-       particles_per_point,                                                                        &
-       particle_advection_start,                                                                   &
-       particle_advection_interpolation,                                                           &
-       particle_maximum_age,                                                                       &
-       pdx,                                                                                        &
-       pdy,                                                                                        &
-       pdz,                                                                                        &
-       psb,                                                                                        &
-       psl,                                                                                        &
-       psn,                                                                                        &
-       psr,                                                                                        &
-       pss,                                                                                        &
-       pst,                                                                                        &
-       radius,                                                                                     &
-       radius_classes,                                                                             &
-       radius_merge,                                                                               &
-       radius_split,                                                                               &
-       random_start_position,                                                                      &
-       read_particles_from_restartfile,                                                            &
-       rm,                                                                                         &
-       seed_follows_topography,                                                                    &
-       splitting,                                                                                  &
-       splitting_factor,                                                                           &
-       splitting_factor_max,                                                                       &
-       splitting_function,                                                                         &
-       splitting_mode,                                                                             &
-       step_dealloc,                                                                               &
-       use_sgs_for_particles,                                                                      &
-       vertical_particle_advection,                                                                &
-       weight_factor_merge,                                                                        &
-       weight_factor_split,                                                                        &
-       write_particle_statistics
+    CHARACTER(LEN=100) ::  line  !< string containing current line of file PARIN
+
+    INTEGER(iwp) ::  io_status  !< status after reading the namelist file
 
     NAMELIST /particle_parameters/                                                                 &
@@ -699,59 +646,27 @@
 
 !
-!-- Position the namelist-file at the beginning (it was already opened in parin), search for the
-!-- namelist-group of the package and position the file at this line. Do the same for each
-!-- optionally used package.
-    line = ' '
-
-!
-!-- Try to find particles package
-    REWIND ( 11 )
-    line = ' '
-    DO   WHILE ( INDEX( line, '&particle_parameters' ) == 0 )
-       READ ( 11, '(A)', END=12 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-!
-!-- Read user-defined namelist
-    READ ( 11, particle_parameters, ERR = 10 )
-!
-!-- Set flag that indicates that particles are switched on
-    particle_advection = .TRUE.
-
-    GOTO 14
-
-10  BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'particle_parameters', line )
-!
-!-- Try to find particles package (old namelist)
-12  REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&particles_par' ) == 0 )
-       READ ( 11, '(A)', END=14 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-!
-!-- Read user-defined namelist
-    READ ( 11, particles_par, ERR = 13, END = 14 )
-
-    message_string = 'namelist particles_par is deprecated and will be ' //                        &
-                     'removed in near future. Please use namelist ' //                             &
-                     'particle_parameters instead'
-    CALL message( 'package_parin', 'PA0487', 0, 1, 0, 6, 0 )
-
-!
-!-- Set flag that indicates that particles are switched on
-    particle_advection = .TRUE.
-
-    GOTO 14
-
-13    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
-       CALL parin_fail_message( 'particles_par', line )
-
-14 CONTINUE
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, particle_parameters, IOSTAT=io_status )
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    particle_parameters namelist was found and read correctly. Set flag that indicates that
+!--    particles are switched on.
+       particle_advection = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    particle_parameters namelist was found, but contained errors. Print an error message
+!--    including the line that caused the error.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)' ) line
+       CALL parin_fail_message( 'particle_parameters', line )
+
+    ENDIF
 
  END SUBROUTINE lpm_parin
+
 
 !--------------------------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4842)
@@ -24,4 +24,9 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more,
+! deprecated namelist removed
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Enable 3D data output also with 64-bit precision
 !
@@ -4995,55 +5000,10 @@
  SUBROUTINE lsm_parin
 
-    USE control_parameters,                                                                        &
-        ONLY:  message_string
-
     IMPLICIT NONE
 
-    CHARACTER (LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
-
-    NAMELIST /lsm_par/         aero_resist_kray,                                                   &
-                               alpha_vangenuchten,                                                 &
-                               c_surface,                                                          &
-                               canopy_resistance_coefficient,                                      &
-                               constant_roughness,                                                 &
-                               conserve_water_content,                                             &
-                               deep_soil_temperature,                                              &
-                               dz_soil,                                                            &
-                               f_shortwave_incoming,                                               &
-                               field_capacity,                                                     &
-                               hydraulic_conductivity,                                             &
-                               l_vangenuchten,                                                     &
-                               lambda_surface_stable,                                              &
-                               lambda_surface_unstable,                                            &
-                               leaf_area_index,                                                    &
-                               min_canopy_resistance,                                              &
-                               min_soil_resistance,                                                &
-                               n_vangenuchten,                                                     &
-                               pavement_depth_level,                                               &
-                               pavement_heat_capacity,                                             &
-                               pavement_heat_conduct,                                              &
-                               pavement_type,                                                      &
-                               residual_moisture,                                                  &
-                               root_fraction,                                                      &
-                               saturation_moisture,                                                &
-                               skip_time_do_lsm,                                                   &
-                               soil_moisture,                                                      &
-                               soil_temperature,                                                   &
-                               soil_type,                                                          &
-                               surface_type,                                                       &
-                               vegetation_coverage,                                                &
-                               vegetation_type,                                                    &
-                               water_temperature,                                                  &
-                               water_type,                                                         &
-                               wilting_point,                                                      &
-                               z0_pavement,                                                        &
-                               z0_vegetation,                                                      &
-                               z0_water,                                                           &
-                               z0h_pavement,                                                       &
-                               z0h_vegetation,                                                     &
-                               z0h_water,                                                          &
-                               z0q_pavement,                                                       &
-                               z0q_vegetation,                                                     &
-                               z0q_water
+    CHARACTER(LEN=100) ::  line  !< dummy string that contains the current line of the parameter
+                                 !< file
+    INTEGER(iwp)  ::  io_status  !< status after reading the nameslist file
+
 
     NAMELIST /land_surface_parameters/  aero_resist_kray,                                          &
@@ -5092,59 +5052,26 @@
                                         z0q_water
 
-    line = ' '
-
-!
-!-- Try to find land surface model package
-    REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&land_surface_parameters' ) == 0 )
-       READ ( 11, '(A)', END=12 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read user-defined namelist
-    READ ( 11, land_surface_parameters, ERR = 10 )
-
-!
-!-- Set flag that indicates that the land surface model is switched on
-    land_surface = .TRUE.
-
-    GOTO 14
-
-10  BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'land_surface_parameters', line )
-!
-!-- Try to find old namelist
-12  REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&lsm_par' ) == 0 )
-       READ ( 11, '(A)', END=14 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read user-defined namelist
-    READ ( 11, lsm_par, ERR = 13, END = 14 )
-
-    message_string = 'namelist lsm_par is deprecated and will be ' //                              &
-                     'removed in near future. Please use namelist ' //                             &
-                     'land_surface_parameters instead'
-    CALL message( 'lsm_parin', 'PA0487', 0, 1, 0, 6, 0 )
-
-!
-!-- Set flag that indicates that the land surface model is switched on
-    land_surface = .TRUE.
-
-    GOTO 14
-
-13  BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'lsm_par', line )
-
-
-14  CONTINUE
-
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, land_surface_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    land_surface_parameters namelist was found and read correctly. Set flag that indicates that
+!--    the land surface model is switched on.
+       land_surface = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    land_surface_parameters namelist was found but contained errors. Print an error message
+!--    including the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'land_surface_parameters', line )
+
+    ENDIF
 
  END SUBROUTINE lsm_parin
